Merge commit 'c47037c7a17e4026d38dfa41da27b9f91506725b'
[ffmpeg.git] / tests / fate-run.sh
1 #! /bin/sh
2
3 export LC_ALL=C
4
5 base=$(dirname $0)
6 . "${base}/md5.sh"
7
8 base64=tests/base64
9
10 test="${1#fate-}"
11 samples=$2
12 target_exec=$3
13 target_path=$4
14 command=$5
15 cmp=${6:-diff}
16 ref=${7:-"${base}/ref/fate/${test}"}
17 fuzz=${8:-1}
18 threads=${9:-1}
19 thread_type=${10:-frame+slice}
20 cpuflags=${11:-all}
21 cmp_shift=${12:-0}
22 cmp_target=${13:-0}
23 size_tolerance=${14:-0}
24 cmp_unit=${15:-2}
25 gen=${16:-no}
26
27 outdir="tests/data/fate"
28 outfile="${outdir}/${test}"
29 errfile="${outdir}/${test}.err"
30 cmpfile="${outdir}/${test}.diff"
31 repfile="${outdir}/${test}.rep"
32
33 target_path(){
34     test ${1} = ${1#/} && p=${target_path}/
35     echo ${p}${1}
36 }
37
38 # $1=value1, $2=value2, $3=threshold
39 # prints 0 if absolute difference between value1 and value2 is <= threshold
40 compare(){
41     echo "scale=2; v = $1 - $2; if (v < 0) v = -v; if (v > $3) r = 1; r" | bc
42 }
43
44 do_tiny_psnr(){
45     psnr=$(tests/tiny_psnr "$1" "$2" $cmp_unit $cmp_shift 0)
46     val=$(expr "$psnr" : ".*$3: *\([0-9.]*\)")
47     size1=$(expr "$psnr" : '.*bytes: *\([0-9]*\)')
48     size2=$(expr "$psnr" : '.*bytes:[ 0-9]*/ *\([0-9]*\)')
49     val_cmp=$(compare $val $cmp_target $fuzz)
50     size_cmp=$(compare $size1 $size2 $size_tolerance)
51     if [ "$val_cmp" != 0 ] || [ "$size_cmp" != 0 ]; then
52         echo "$psnr"
53         return 1
54     fi
55 }
56
57 oneoff(){
58     do_tiny_psnr "$1" "$2" MAXDIFF
59 }
60
61 stddev(){
62     do_tiny_psnr "$1" "$2" stddev
63 }
64
65 oneline(){
66     printf '%s\n' "$1" | diff -u -b - "$2"
67 }
68
69 run(){
70     test "${V:-0}" -gt 0 && echo "$target_exec" $target_path/"$@" >&3
71     $target_exec $target_path/"$@"
72 }
73
74 probefmt(){
75     run ffprobe -show_entries format=format_name -print_format default=nw=1:nk=1 -v 0 "$@"
76 }
77
78 ffmpeg(){
79     dec_opts="-threads $threads -thread_type $thread_type"
80     ffmpeg_args="-nostats -cpuflags $cpuflags"
81     for arg in $@; do
82         [ x${arg} = x-i ] && ffmpeg_args="${ffmpeg_args} ${dec_opts}"
83         ffmpeg_args="${ffmpeg_args} ${arg}"
84     done
85     run ffmpeg ${ffmpeg_args}
86 }
87
88 framecrc(){
89     ffmpeg "$@" -f framecrc -
90 }
91
92 framemd5(){
93     ffmpeg "$@" -f framemd5 -
94 }
95
96 crc(){
97     ffmpeg "$@" -f crc -
98 }
99
100 md5(){
101     ffmpeg "$@" md5:
102 }
103
104 pcm(){
105     ffmpeg "$@" -vn -f s16le -
106 }
107
108 enc_dec_pcm(){
109     out_fmt=$1
110     dec_fmt=$2
111     pcm_fmt=$3
112     src_file=$(target_path $4)
113     shift 4
114     encfile="${outdir}/${test}.${out_fmt}"
115     cleanfiles=$encfile
116     encfile=$(target_path ${encfile})
117     ffmpeg -i $src_file "$@" -f $out_fmt -y ${encfile} || return
118     ffmpeg -flags +bitexact -i ${encfile} -c:a pcm_${pcm_fmt} -f ${dec_fmt} -
119 }
120
121 FLAGS="-flags +bitexact -sws_flags +accurate_rnd+bitexact"
122 DEC_OPTS="-threads $threads -idct simple $FLAGS"
123 ENC_OPTS="-threads 1        -idct simple -dct fastint"
124
125 enc_dec(){
126     src_fmt=$1
127     srcfile=$2
128     enc_fmt=$3
129     enc_opt=$4
130     dec_fmt=$5
131     dec_opt=$6
132     encfile="${outdir}/${test}.${enc_fmt}"
133     decfile="${outdir}/${test}.out.${dec_fmt}"
134     cleanfiles="$cleanfiles $decfile"
135     test "$7" = -keep || cleanfiles="$cleanfiles $encfile"
136     tsrcfile=$(target_path $srcfile)
137     tencfile=$(target_path $encfile)
138     tdecfile=$(target_path $decfile)
139     ffmpeg -f $src_fmt $DEC_OPTS -i $tsrcfile $ENC_OPTS $enc_opt $FLAGS \
140         -f $enc_fmt -y $tencfile || return
141     do_md5sum $encfile
142     echo $(wc -c $encfile)
143     ffmpeg $8 $DEC_OPTS -i $tencfile $ENC_OPTS $dec_opt $FLAGS \
144         -f $dec_fmt -y $tdecfile || return
145     do_md5sum $decfile
146     tests/tiny_psnr $srcfile $decfile $cmp_unit $cmp_shift
147 }
148
149 lavffatetest(){
150     t="${test#lavf-fate-}"
151     ref=${base}/ref/lavf-fate/$t
152     ${base}/lavf-regression.sh $t lavf-fate tests/vsynth1 "$target_exec" "$target_path" "$threads" "$thread_type" "$cpuflags" "$samples"
153 }
154
155 lavftest(){
156     t="${test#lavf-}"
157     ref=${base}/ref/lavf/$t
158     ${base}/lavf-regression.sh $t lavf tests/vsynth1 "$target_exec" "$target_path" "$threads" "$thread_type" "$cpuflags" "$samples"
159 }
160
161 video_filter(){
162     filters=$1
163     shift
164     label=${test#filter-}
165     raw_src="${target_path}/tests/vsynth1/%02d.pgm"
166     printf '%-20s' $label
167     ffmpeg $DEC_OPTS -f image2 -vcodec pgmyuv -i $raw_src \
168         $FLAGS $ENC_OPTS -vf "$filters" -vcodec rawvideo $* -f nut md5:
169 }
170
171 pixdesc(){
172     pix_fmts="$(ffmpeg -pix_fmts list 2>/dev/null | awk 'NR > 8 && /^IO/ { print $2 }' | sort)"
173     for pix_fmt in $pix_fmts; do
174         test=$pix_fmt
175         video_filter "format=$pix_fmt,pixdesctest" -pix_fmt $pix_fmt
176     done
177 }
178
179 pixfmts(){
180     filter=${test#filter-pixfmts-}
181     filter=${filter%_*}
182     filter_args=$1
183     prefilter_chain=$2
184
185     showfiltfmts="$target_exec $target_path/libavfilter/filtfmts-test"
186     scale_exclude_fmts=${outfile}_scale_exclude_fmts
187     scale_in_fmts=${outfile}_scale_in_fmts
188     scale_out_fmts=${outfile}_scale_out_fmts
189     in_fmts=${outfile}_in_fmts
190
191     # exclude pixel formats which are not supported as input
192     $showfiltfmts scale | awk -F '[ \r]' '/^INPUT/{ fmt=substr($3, 5); print fmt }' | sort >$scale_in_fmts
193     $showfiltfmts scale | awk -F '[ \r]' '/^OUTPUT/{ fmt=substr($3, 5); print fmt }' | sort >$scale_out_fmts
194     comm -12 $scale_in_fmts $scale_out_fmts >$scale_exclude_fmts
195
196     $showfiltfmts $filter | awk -F '[ \r]' '/^INPUT/{ fmt=substr($3, 5); print fmt }' | sort >$in_fmts
197     pix_fmts=$(comm -12 $scale_exclude_fmts $in_fmts)
198
199     for pix_fmt in $pix_fmts; do
200         test=$pix_fmt
201         video_filter "${prefilter_chain}format=$pix_fmt,$filter=$filter_args" -pix_fmt $pix_fmt
202     done
203
204     rm $in_fmts $scale_in_fmts $scale_out_fmts $scale_exclude_fmts
205 }
206
207 mkdir -p "$outdir"
208
209 # Disable globbing: command arguments may contain globbing characters and
210 # must be kept verbatim
211 set -f
212
213 exec 3>&2
214 eval $command >"$outfile" 2>$errfile
215 err=$?
216
217 if [ $err -gt 128 ]; then
218     sig=$(kill -l $err 2>/dev/null)
219     test "${sig}" = "${sig%[!A-Za-z]*}" || unset sig
220 fi
221
222 if test -e "$ref" || test $cmp = "oneline" ; then
223     case $cmp in
224         diff)   diff -u -b "$ref" "$outfile"            >$cmpfile ;;
225         oneoff) oneoff     "$ref" "$outfile"            >$cmpfile ;;
226         stddev) stddev     "$ref" "$outfile"            >$cmpfile ;;
227         oneline)oneline    "$ref" "$outfile"            >$cmpfile ;;
228         null)   cat               "$outfile"            >$cmpfile ;;
229     esac
230     cmperr=$?
231     test $err = 0 && err=$cmperr
232     test $err = 0 || cat $cmpfile
233 else
234     echo "reference file '$ref' not found"
235     err=1
236 fi
237
238 echo "${test}:${sig:-$err}:$($base64 <$cmpfile):$($base64 <$errfile)" >$repfile
239
240 if test $err != 0 && test $gen != "no" ; then
241     echo "GEN     $ref"
242     cp -f "$outfile" "$ref"
243     err=$?
244 fi
245
246 if test $err = 0; then
247     rm -f $outfile $errfile $cmpfile $cleanfiles
248 elif test $gen = "no"; then
249     echo "Test $test failed. Look at $errfile for details."
250 else
251     echo "Updating reference failed, possibly no output file was generated."
252 fi
253 exit $err